/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.admin.autostart.view {

    import com.adobe.cairngorm.control.CairngormEventDispatcher;
    import org.ow2.jonas.admin.autostart.event.*;
    import org.ow2.jonas.admin.autostart.model.*;
    import org.ow2.jonas.admin.autostart.vo.*;

    import mx.containers.VBox;
    import mx.collections.ArrayCollection;

    public class StarterListViewClass extends VBox {

        [Bindable]
        public var model : BuilderModelLocator = BuilderModelLocator.getInstance();

        [Bindable]
        public var starterDescription : String;

        [Bindable]
        public var starterPath : String;

        [Bindable]
        public var starterCreationDate : String;

        [Bindable]
        public var starterEmbeddedAppli : ArrayCollection;

        /**
         * Default constructor.
         */
        public function StarterListViewClass() {
        }

        public function init():void {
            loadStarters();
        }

        public function loadStarters():void {
            //Load starters from the xml file.
            var event : BuilderEvent =
                    new BuilderEvent(BuilderEvent.EVENT_LOAD_STARTERS + model.componentID);
            CairngormEventDispatcher.getInstance().dispatchEvent(event);
        }

        public function reloadStarters(selectedStarter : Object):void {
	        cleanStarterInformations();
            loadStarters();
            selectedStarter.selectedIndex = -1;
        }

        /**
         * Delete a selected starter.
         * @param selectedItem the starter name.
         */
        public function deleteSelectedStarter(selectedStarter : Object) : void {
            /*for (var i:uint = 0; i < model.builderVO.starters.length; i++) {
                var starter : StarterVO = model.builderVO.starters[i];*/
            var starter : StarterVO = new StarterVO();
            for (var i:uint = 0; i < model.builderVO.starters.length; i++) {
                var object : Object = model.builderVO.starters.getItemAt(i);
                starter.init(object);
                if (starter.jonasStarterName == selectedStarter){
                    model.builderVO.starters.removeItemAt(i);
                    model.jonasStarterList.removeItemAt(i);
                    cleanStarterInformations();
                    model.builderVO.parameter = starter.jonasStarterName;
                    var eventDeleteStarter : BuilderEvent =
                    new BuilderEvent(BuilderEvent.EVENT_DELETE_STARTER + model.componentID);
                    CairngormEventDispatcher.getInstance().dispatchEvent(
                        eventDeleteStarter);
                    var eventSaveStarter : BuilderEvent =
                    new BuilderEvent(BuilderEvent.EVENT_SAVE_STARTER_INFO_IN_FILE
                            + model.componentID);
                    CairngormEventDispatcher.getInstance().dispatchEvent(
                        eventSaveStarter);
                    return;
                }
            }/**/
            /*var starter : StarterVO = new StarterVO();
            for (var i:uint = 0; i < model.builderVO.starters.length; i++) {
                var object : Object = model.builderVO.starters.getItemAt(i);
                starter.init(object);
                if (starter.jonasStarterName == selectedStarter){
                    model.builderVO.starters.removeItemAt(i);
                    model.jonasStarterList.removeItemAt(i);
                    cleanStarterInformations();
                    model.builderVO.parameter = starter.jonasStarterName;
                    var eventDeleteStarter : BuilderEvent =
                    new BuilderEvent(BuilderEvent.DELETE_STARTER,
                        model.builderVO);
                    CairngormEventDispatcher.getInstance().dispatchEvent(
                        eventDeleteStarter);
                    var eventSaveStarter : BuilderEvent =
                    new BuilderEvent(BuilderEvent.SAVE_STARTER_INFO_IN_FILE,
                        model.builderVO);
                    CairngormEventDispatcher.getInstance().dispatchEvent(
                        eventSaveStarter);
                    return;
                }
            }*/
        }

        /**
         * Reset the starter information.
         */
        private function cleanStarterInformations() : void {
            starterDescription = "";
            starterPath = "";
            starterCreationDate = "";
            starterEmbeddedAppli = new ArrayCollection();
        }
    }
}
